<% 
  '---------------------------------------------------------------- 
  '程序简介: 完成asp语言对XML文档中指定节点文本的增加、删除、修改、查看 
  '入口参数: 无 
  '出口参数: 无 
  '------------------------------------------------ 
  '函数名字：ConnectXml() 
  '入口参数: filename 需要连接或打开的xml文件名 
  '出口参数: 无 
  '返回值 ：ConnectXml=0，XMLMorntekDocument就是一个成功装载XML文档的对象了。 
  ' ConnectXml<>0,则打印错误信息strError 
  '------------------------------------------------ 
Class Bizcn_XMLCLS

Private XMLMorntekDocument
Private p_Debug,p_ErrorMsg
Private p_XmlFileName
Private p_XmlDomObjName
Public SubNodes,Length
Public XmlStrings,LoadType
Public W,U,P


Sub Class_Initialize() 
	p_Debug=False
	p_ErrorMsg=""
	p_XmlFileName=""
	p_XmlDomObjName="Microsoft.XMLDOM"
	XmlStrings=""
	LoadType="load"
End Sub

Private Sub Class_terminate()
 If IsObject(XMLMorntekDocument) Then Set XMLMorntekDocument=Nothing
End Sub 

 Public Property Get XmlFileName
  XmlFileName=p_XmlFileName
 End Property
 Public Property Let XmlFileName(XFNStrings)
  If XFNStrings<>"" Then
   p_XmlFileName=XFNStrings
  End If
 End Property
  
 Public Property Get ErrorMsg
  ErrorMsg=p_ErrorMsg
 End Property

 Public Property Get Debug
  Debug=p_Debug
 End Property
 Public Property Let Debug(BoolDebug)
  If BoolDebug Then
   p_Debug=True
  Else
   p_Debug=False
  End If
 End Property
 
 
 Private Sub ConnectXml() 
  dim strSourceFile,strError
  Set XMLMorntekDocument = Server.CreateObject(p_XmlDomObjName) 
  XMLMorntekDocument.async = false 
  if LoadType="LoadXML" then
  	XMLMorntekDocument.loadXML(XmlStrings)
  else
	  strSourceFile = Server.MapPath(p_XmlFileName)
	  XMLMorntekDocument.load(strSourceFile)
  end if
  if XMLMorntekDocument.parseerror.errorcode<>0 then 
	  strError="<h2>error"&XMLMorntekDocument.parseerror.errorcode&"</h2>" 
	  strError=strError&XMLMorntekDocument.parseerror.reason&"<br>" 
	  strError=strError&XMLMorntekDocument.parseerror.url&"<br>" 
	  strError=strError&XMLMorntekDocument.parseerror.line&"<br>" 
	  strError=strError&XMLMorntekDocument.parseerror.filepos&"<br>" 
	  strError=strError&XMLMorntekDocument.parseerror.srcText&"<br>" 
	  p_ErrorMsg=strError 
  end if 
  End Sub

 Public Sub ReConnectXML()
 	ConnectXml()
 End Sub
  '------------------------------------------------ 
  '函数名字：RootNode() 
  '入口参数:  
  '出口参数: 无 
  '------------------------------------------------ 
  Public function RootNode()
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
  Set RootNode = XMLMorntekDocument.documentElement
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		Set RootNode = Nothing
  End If
  end function 
  '------------------------------------------------ 
  '函数名字：SelectXmlNodeText(elementname) 
  '入口参数: elementname 元素的名字 
  '出口参数: 无 
  '------------------------------------------------ 
  Public function SelectXmlNodeText(elementname)
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
   elementname="//"&elementname
   dim temp
   temp=XMLMorntekDocument.selectSingleNode(elementname).text 
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		selectXmlNodeText = ""
  Else
  		selectXmlNodeText = server.htmlencode(temp)
  End If
  end function 
  '------------------------------------------------ 
  '函数名字：GetXMLTagText(elementname) 
  '入口参数: elementname 元素的名字 
  '出口参数: 无 
  '------------------------------------------------ 
  Public function GetXMLTagText(elementname)
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
   dim temp
   temp=XMLMorntekDocument.getElementsByTagName(elementname).item(0).text 
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		GetXMLTagText = ""
  Else
  		GetXMLTagText = server.htmlencode(temp)
  End If
  end function 
  '------------------------------------------------ 
  '函数名字：GetXMLTagAttrib(elementname,attribname) 
  '入口参数: elementname 元素的名字 , attribname 属性的名字
  '出口参数: 无 
  '------------------------------------------------ 
  Public function GetXMLTagAttrib(elementname,attribname)
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
   dim temp
   temp=XMLMorntekDocument.getElementsByTagName(elementname).item(0).getAttributeNode(attribname).nodeValue
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		GetXMLTagAttrib = ""
  Else
  		GetXMLTagAttrib = server.htmlencode(temp)
  End If
  end function
  '------------------------------------------------ 
  '函数名字：SelectXmlNodeLength(elementname) 
  '入口参数: elementname 元素的名字 
  '出口参数: 无 
  '------------------------------------------------ 
  Public function SelectXmlNodeLength(elementname)
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
   elementname="//"&elementname
   dim temp
   temp=XMLMorntekDocument.selectNodes(elementname).length
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		SelectXmlNodeLength = 0
  Else
  		SelectXmlNodeLength = temp
  End If
  end function

  '------------------------------------------------ 
  '函数名字：GetXMLTagText(elementname) 
  '入口参数: elementname 元素的名字 
  '出口参数: 无 
  '------------------------------------------------ 
  Public function GetXMLTagTexts(elementname,IndexNum)
  On Error Resume Next
  IndexNum = cint(IndexNum)
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
   dim temp
   temp=XMLMorntekDocument.getElementsByTagName(elementname).item(IndexNum).text 
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		GetXMLTagTexts = ""
  Else
  		GetXMLTagTexts = server.htmlencode(temp)
  End If
  end function 
  '------------------------------------------------ 
  '函数名字：GetXMLTagAttrib(elementname,attribname) 
  '入口参数: elementname 元素的名字 , attribname 属性的名字
  '出口参数: 无 
  '------------------------------------------------ 
  Public function GetXMLTagAttribs(elementname,attribname,IndexNum)
  On Error Resume Next
  IndexNum = cint(IndexNum)
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
   dim temp
   temp=XMLMorntekDocument.getElementsByTagName(elementname).item(IndexNum).getAttributeNode(attribname).nodeValue
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		GetXMLTagAttribs = ""
  Else
  		GetXMLTagAttribs = server.htmlencode(temp)
  End If
  end function
  '------------------------------------------------ 
  '函数名字：InsertXmlNodeText(befelementname,elementname,elementtext) 
  '入口参数: elementname 插入的元素的名字 
  ' befelementname在此元素的名字前面插入元素 
  ' elementtext 插入的元素的文本 
  '出口参数: 无 
  '------------------------------------------------ 
  Public function InsertXmlNodeText(befelementname,elementname,elementtext)
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
  dim befelement,element
  set befelement=XMLMorntekDocument.selectSingleNode("//"&befelementname) 
  set element= XMLMorntekDocument.createelement(elementname)
  befelement.insertBefore element,befelement.firstchild
  element.text=elementtext
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		InsertXmlNodeText = False
  Else
  		InsertXmlNodeText = True
  End If
  end function
   
  '------------------------------------------------ 
  '函数名字：UpdateXmlNodeText(elementname,newelementtext)
  '入口参数: elementname 元素的名字
  ' newelementtext元素的新文本
  '出口参数: 无
  '------------------------------------------------ 
  Public function UpdateXmlNodeText(elementname,newelementtext)
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
  dim element
  set element=XMLMorntekDocument.selectSingleNode("//"&elementname)
  element.text=newelementtext
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		UpdateXmlNodeText = False
  Else
  		UpdateXmlNodeText = True
  End If
  end function
   
  '------------------------------------------------ 
  '函数名字：DeleteXmlNodeText(elementname) 
  '入口参数: elementname 元素的名字 
  '出口参数: 无 
  '------------------------------------------------ 
  Public function DeleteXmlNodeText(elementname)
  On Error Resume Next
  If NOT IsObject(XMLMorntekDocument) Then ConnectXml
  XMLMorntekDocument.selectSingleNode("//"&elementname).text =""
  If Err then
  	if Debug then p_ErrorMsg = Err.Description
		Err.Clear
		DeleteXmlNodeText = False
  Else
  		DeleteXmlNodeText = True
  End If
  end function
  
  Public Function MakeWSXml(ByVal Method,ByVal Strings)
  Dim WSXMLStrings
	WSXMLStrings = "<soapenv:Envelope xmlns:soapenv=""http://schemas.xmlsoap.org/soap/envelope/"" xmlns:ws=""http://ws/"">" & _
	"<soapenv:Header/>" & _
	"<soapenv:Body>" & _
	"<ws:" & Method & ">" & _
	"<user>" & _
	"<name>" & U & "</name>" & _
	"<password>" & P& "</password>" & _
	"</user>" & Strings & _
	"</ws:" & Method & ">" & _
	"</soapenv:Body>" & _
	"</soapenv:Envelope>"
	MakeWSXml = WSXMLStrings
  End Function
  
  Public Function GetWS(ByVal WSXMLStrings,ByVal AttribName)
  On Error Resume Next
  Dim XmlHttp,Result_code,result
  	Set XmlHttp = server.CreateObject("Msxml2.XMLHTTP") '创建XMLHTTP对象
	XmlHttp.Open "POST",W,false '用POST方式
	XmlHttp.setRequestHeader "Content-Type", "text/xml;charset=utf-8" '设置UTF8编码
	XmlHttp.setRequestHeader "Content-Length",LEN(WSXMLStrings) '提交内容长度
	XmlHttp.Send(WSXMLStrings)
	If XmlHttp.Status = 200 Then
		LoadType="LoadXML"
		XmlStrings = XmlHttp.responseText
'		Response.write GetXMLTagAttrib("result","code") '测试输出result code
		result_code = GetXMLTagAttrib("result","code") '200为正常
		if cstr(result_code) = "200" then
			If IsArray(AttribName) then
				if Ubound(AttribName)=1 then
					result = GetXMLTagAttrib(AttribName(0),AttribName(1))
					GetWS = cstr(result)
					exit function
				elseif Ubound(AttribName)=2 then
					ReDim ResultArray(AttribName(2))
					Dim i
					for i=0 to cInt(AttribName(2))
						ResultArray(i) = GetXMLTagAttribs(AttribName(0),AttribName(1),i)
					next
					GetWS = ResultArray
					exit function
				else
					GetWS = false
					p_ErrorMsg = "参数错误"
					Set XmlHttp = Nothing
					exit function
				end if
			elseif AttribName<>"" then
				result = GetXMLTagText(AttribName)
				GetWS = cstr(result)
				Set XmlHttp = Nothing
				exit function
			else
				GetWS = true
				Set XmlHttp = Nothing
				Exit Function
			end if
		else
			GetWS = false
			if Debug then
				p_ErrorMsg = p_ErrorMsg & VbCrlf & "服务器请求错误: Code: " & result_code & " | MSG: " & GetXMLTagText("msg")
			end if
			Set XmlHttp = Nothing
			exit function
		end if
	Else
			GetWS = false
		if Debug then
			p_ErrorMsg = p_ErrorMsg & VbCrlf & "连接错误: Code: " & XmlHttp.Status & " | MSG: " & XmlHttp.StatusText
		end if
		Set XmlHttp = Nothing
		exit function
	End if
	Set XmlHttp = Nothing
	if err then err.clear
  End Function

End Class%> 